'-------------------------------------------------------------------------------
'  Controler pentru  TDA7318
'  versiune - 13.0      (c)danzup
'-------------------------------------------------------------------------------
$regfile = "m8515.dat"                                      'register file for ATmega8515
$crystal = 8000000                                          '8MHz crystal
Config Lcdbus = 4
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Ddrd = &B11000000                                           ' PD6...PD7 are output, PD0...PD5 are input
Portd = &B00111111                                          ' PD0...PD5 pull-up resistor enable
Config Scl = Porta.1
Config Sda = Porta.0
Config I2cdelay = 10
Config Rc5 = Pind.3                                         'pin where is conected ir senzor
I2cinit
Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Start Timer1
Set Portd.7                                                 'LCD backlight on
Set Portd.6                                                 'power relay
Dim Address As Byte , Command As Byte                       'RC5 ir variable
Dim Menu As Bit                                             'first button
Dim Plus As Bit                                             'second button
Dim Minus As Bit                                            'third button
Dim Onoff As Bit                                            'four button
Dim W As Word
Dim A As Byte
Dim B As Byte
Dim C As Byte
Dim Pwr As Bit
Dim E As Byte
Dim D As Single
Dim F As Byte
Dim G As Byte
Dim Mask As Byte
A = 7
B = 1
C = 1
E = 30
G = 30
Pwr = 0
Dim H As Bit
Dim Tont As Byte
Dim Tonb As Byte
Dim Vol_me As Byte
Dim Inp_ut As Byte
Dim Att_lr As Byte
Dim Att_rr As Byte
Dim Att_lf As Byte
Dim Att_rf As Byte
Dim Bas_ss As Byte
Dim Tre_le As Byte
Dim Gain As Byte
Dim Gain_v As Byte
Dim Gain_d As Single
Dim Gain_d1 As Single
Dim Gain_d2 As Single
Dim Gain_d3 As Single
Dim Gain_d4 As Single
Dim Temp As Byte
Gain_d1 = 0
Gain_d2 = 0
Gain_d3 = 0
Gain_d4 = 0
Tont = 8
Tonb = 8
Gain_v = &B00011000
Gain_d = 0
Vol_me = &B00100000                                         'default volum -40dB
Inp_ut = &B01011000                                         'default intrarea stereo1 ;gain 0db   ( 88 )
Att_lr = &B11000000                                         'default atenuare lr 0dB   ( 192 )
Att_rr = &B11100000                                         'default atenuare rr 0dB   ( 224 )
Att_lf = &B10000000                                         'default atenuare lr 0dB   ( 128 )
Att_rf = &B10100000                                         'default atenuare rr 0dB   ( 160 )
Bas_ss = &B01100111                                         'default 0dB ( 103 )
Tre_le = &B01110111                                         'default 0dB ( 119 )

'-----------------------------------------------------------------
Dim Char_pos As Byte
Dim Bar_len As Word
Dim T1 As Single
Const Char_max = 16                                         'number of LCD characters (one row)
Deflcdchar 5 , 27 , 27 , 27 , 27 , 27 , 27 , 27 , 32        ' bar
Cls                                                         '
Cursor Off
Declare Sub Mmenu
Declare Sub Mplus
Declare Sub Mminus
Declare Sub Monoff
Declare Sub Tonesh
Declare Sub Tonesj
Declare Sub Pwr_on
Declare Sub Pwr_off
Declare Sub Inpt_gain
Declare Sub Displ
Declare Sub Inpt_chgn
'Declare Sub Mute
Cls
Lcd "TDA7318 Control "
Locate 2 , 1
Lcd "v.13(c)by danzup"
Wait 2
Cls
'--incarc toata cofiguratia default in TDA----
I2csend &H88 , Vol_me
I2csend &H88 , Att_rf
I2csend &H88 , Att_lf
I2csend &H88 , Att_rr
I2csend &H88 , Att_lr
I2csend &H88 , Tre_le
I2csend &H88 , Bas_ss
I2csend &H88 , Inp_ut
'---------------------------------------------
Call Pwr_off
Enable Interrupts
Reset Portd.7
Reset Portd.6
Do
If Pwr = 1 Then
 W = Timer1
  If W => 59990 Then
   A = 7
   Call Mmenu
  End If
Getrc5(address , Command)                                   'read if we have remote ir command
  If Address = 10 Then
     Command = Command And &B01111111
  End If
Select Case Command
'---- this codes are for my remote , change code to your suit ! ----------------
   Case 32 : Call Mmenu                                     'remote command code for CH up
   Case 161 : Call Mmenu
   Case 33 : Call Mmenu                                     'remote command code for CH down
   Case 160 : Call Mmenu
   Case 17 : Call Mplus                                     'remote command code for Vol +
   Case 145 : Call Mplus
   Case 16 : Call Mminus                                    'remote command code for Vol -
   Case 144 : Call Mminus
   Case 12 : Call Monoff                                    'remote command code for On/Off
   Case 140 : Call Monoff
End Select
 Menu = Pind.4                                              '
 Plus = Pind.1                                              '
 Minus = Pind.0                                             '
 Onoff = Pind.5                                             '
 If Menu = 0 Then                                           'now we read the push buttons for command
      Waitms 5
      Call Mmenu                                            'button for menu presed
 End If
 If Plus = 0 Then
      Waitms 5
      Call Mplus                                            'button Plus presed
 End If
 If Minus = 0 Then
      Waitms 5
      Call Mminus                                           'button Minus presed
 End If
 If Onoff = 0 Then
      Waitms 5
      Call Monoff                                           'button On/off presed

 End If
End If
If Pwr = 0 Then
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = 10 Then
     Command = Command And &B01111111
  End If
  Select Case Command
 '---- this codes are for my remote , change code to your suit ! ----------------
  Case 12 : Call Monoff                                     'remote command code for On/Off
  Case 140 : Call Monoff
  End Select
  Onoff = Pind.5
     If Onoff = 0 Then
      Waitms 10
      Call Monoff                                           'button On/off presed
     End If
End If

Loop
End
'-----------Mmenu-----------------
Sub Mmenu:
A = A + 1
Set Portd.7                                                 'backlight on
If A > 6 Then
   A = 0
End If
If A = 0 Then
   Home Upper
   Lcd "-    Volume    +"
   T1 = Vol_me / 3.9375
   Bar_len = 16 - Int(t1)
   Waitms 180
End If
If A = 1 Then
   Home Upper
   Lcd " Select Input   "
   Home Lower
   Lcd "   Input " ; C ; "            "
   Waitms 180
End If
If A = 2 Then
   Home Upper
   Lcd "   Gain Input   "
   Home Lower
Select Case C
   Case 1 : Lcd "Gain In" ; C ; "=" ; Gain_d1 ; " dB  "
   Case 2 : Lcd "Gain In" ; C ; "=" ; Gain_d2 ; " dB  "
   Case 3 : Lcd "Gain In" ; C ; "=" ; Gain_d3 ; " dB  "
   Case 4 : Lcd "Gain In" ; C ; "=" ; Gain_d4 ; " dB  "
End Select
   Waitms 180
End If
If A = 3 Then
   Home Upper
   Lcd "L    Balance   R"
   D = E / 3.75
   Bar_len = Int(d )
   Waitms 180
End If
If A = 4 Then
   Home Upper
   Lcd "F    Fader     R"
   D = G / 3.75
   Bar_len = Int(d )
   Waitms 180
End If
If A = 5 Then
   Home Upper
   Lcd "-    Bass      +"
   Bar_len = Tonb
   Waitms 180
End If
If A = 6 Then
   Home Upper
   Lcd "-    Treble    +"
   Bar_len = Tont
   Waitms 180
End If
Call Displ

End Sub
'-----------Mplus-----------------
Sub Mplus:
'-------regelz volumul-----------------------
If A = 0 Then
  If Vol_me < 63 Then
  Incr Vol_me
  T1 = Vol_me / 3.9375
  Bar_len = 16 - Int(t1)
  I2csend &H88 , Vol_me
  End If
  Call Displ
End If
'------------reglez Balance --------------
If A = 3 Then
Decr Att_lf
Incr Att_rf
 If Att_rf > 190 Then
 Att_rf = 190
 End If
 If Att_lf < 128 Then
 Att_lf = 128
 End If
Decr Att_lr
Incr Att_rr
 If Att_rr > 254 Then
 Att_rr = 254
 End If
 If Att_lr < 192 Then
 Att_lr = 192
 End If
  If E > 1 Then
     Decr E
  End If
   D = E / 3.75
   Bar_len = Int(d )
  I2csend &H88 , Att_rf
  I2csend &H88 , Att_lf
  I2csend &H88 , Att_rr
  I2csend &H88 , Att_lr
  Call Displ
  Waitms 50
End If
'--------------reglez Fader--------------
If A = 4 Then
Incr Att_lf
Incr Att_rf
If Att_lf > 158 Then
Att_lf = 158
End If
If Att_rf > 190 Then
Att_rf = 190
End If
Decr Att_lr
Decr Att_rr
If Att_lr < 192 Then
Att_lr = 192
End If
If Att_rr < 224 Then
Att_rr = 224
End If
  If G > 1 Then
     Decr G
  End If
   D = G / 3.75
   Bar_len = Int(d )
  I2csend &H88 , Att_rf
  I2csend &H88 , Att_lf
  I2csend &H88 , Att_rr
  I2csend &H88 , Att_lr
  Call Displ
  Waitms 50
End If
'------------reglez Bass--------------------------
If A = 5 Then
  H = 1
  Call Tonesh
  Bar_len = Tonb
  Call Displ
End If
'------------reglez Treble-----------------------------
If A = 6 Then
  H = 1
  Call Tonesj
  Bar_len = Tont
  Call Displ
End If
'---------reglez Gain Input--------------------------
If A = 2 Then
  H = 0
  Call Inpt_gain
  Home Lower
Select Case C
   Case 1 : Lcd "Gain In" ; C ; "=" ; Gain_d1 ; " dB  "
   Case 2 : Lcd "Gain In" ; C ; "=" ; Gain_d2 ; " dB  "
   Case 3 : Lcd "Gain In" ; C ; "=" ; Gain_d3 ; " dB  "
   Case 4 : Lcd "Gain In" ; C ; "=" ; Gain_d4 ; " dB  "
End Select
  Waitms 180
End If
'---------modific intrarea selectata-----------
If A = 1 Then
  H = 0
  Call Inpt_chgn
  Home Lower
  Lcd "   Input " ; C ; "           "
  Waitms 180
End If
End Sub
'-----------Mminus-----------------
Sub Mminus:
'------------reglez volum------------------
If A = 0 Then
  If Vol_me > 0 Then
  Decr Vol_me
  T1 = Vol_me / 3.9375
  Bar_len = 16 - Int(t1)
  I2csend &H88 , Vol_me
  End If
  Call Displ
End If
'-------------reglez Balance--------------
If A = 3 Then
Incr Att_lf
Decr Att_rf
If Att_rf < 160 Then
Att_rf = 160
End If
If Att_lf > 158 Then
Att_lf = 158
End If
Incr Att_lr
Decr Att_rr
If Att_rr < 224 Then
Att_rr = 224
End If
If Att_lr > 222 Then
Att_lr = 222
End If
  If E < 60 Then
     Incr E
  End If
   D = E / 3.75
   Bar_len = Int(d )
  I2csend &H88 , Att_rf
  I2csend &H88 , Att_lf
  I2csend &H88 , Att_rr
  I2csend &H88 , Att_lr
  Call Displ
  Waitms 50
End If
'-------------reglez Fader---------------------
If A = 4 Then
 Decr Att_lf
 Decr Att_rf
 If Att_lf < 128 Then
 Att_lf = 128
 End If
 If Att_rf < 160 Then
 Att_rf = 160
 End If
 Incr Att_lr
 Incr Att_rr
 If Att_lr > 222 Then
 Att_lr = 222
 End If
 If Att_rr > 254 Then
 Att_rr = 254
 End If
  If G < 60 Then
     Incr G
  End If
   D = G / 3.75
   Bar_len = Int(d )
  I2csend &H88 , Att_rf
  I2csend &H88 , Att_lf
  I2csend &H88 , Att_rr
  I2csend &H88 , Att_lr
  Call Displ
  Waitms 50
End If
'---------------reglez Bass----------------
If A = 5 Then
  H = 0
  Call Tonesh
  Bar_len = Tonb
  Call Displ
End If
'------------reglez Treble------------------
If A = 6 Then
  H = 0
  Call Tonesj
  Bar_len = Tont
  Call Displ
End If
'-----------reglez Gain Input---------------
If A = 2 Then
  H = 1
  Call Inpt_gain
  Home Lower
  Select Case C
    Case 1 : Lcd "Gain In" ; C ; "=" ; Gain_d1 ; " dB  "
    Case 2 : Lcd "Gain In" ; C ; "=" ; Gain_d2 ; " dB  "
    Case 3 : Lcd "Gain In" ; C ; "=" ; Gain_d3 ; " dB  "
    Case 4 : Lcd "Gain In" ; C ; "=" ; Gain_d4 ; " dB  "
  End Select
  Waitms 180
End If
'---------modific intrarea selectata-----------
If A = 1 Then
  H = 1
  Call Inpt_chgn
  Home Lower
  Lcd "   Input " ; C ; "           "
  Waitms 180
End If
End Sub
'-----------Monoff-----------------
Sub Monoff:
Pwr = Not Pwr
 If Pwr = 1 Then
 Call Pwr_on
 Else
 Call Pwr_off
 End If
End Sub
'------------Pwr_on-------------------------
Sub Pwr_on:
Display On
Decr A
I2csend &H88 , Att_rf
I2csend &H88 , Att_lf
I2csend &H88 , Att_rr
I2csend &H88 , Att_lr
Set Portd.6                                                 'power relay on
Set Portd.7                                                 'backlight on
Waitms 500
Call Mmenu
W = 0
Timer1 = W
End Sub
'------------Pwr_off-------------------------
Sub Pwr_off:
Display Off
I2csend &H88 , &B11111111
I2csend &H88 , &B10011111
I2csend &H88 , &B10111111
I2csend &H88 , &B11011111
Reset Portd.6                                               'power relay off
Reset Portd.7                                               'backlight off
Waitms 500
End Sub
'------------Tonesh----------------------
Sub Tonesh:
Select Case H
Case 1 : Decr Tonb
         If Tonb < 1 Then Tonb = 1
Case 0 : Incr Tonb
         If Tonb > 15 Then Tonb = 15
End Select

Select Case Tonb
   Case 1 : Bas_ss = 96
   Case 2 : Bas_ss = 97
   Case 3 : Bas_ss = 98
   Case 4 : Bas_ss = 99
   Case 5 : Bas_ss = 100
   Case 6 : Bas_ss = 101
   Case 7 : Bas_ss = 102
   Case 8 : Bas_ss = 103
   Case 9 : Bas_ss = 110
   Case 10 : Bas_ss = 109
   Case 11 : Bas_ss = 108
   Case 12 : Bas_ss = 107
   Case 13 : Bas_ss = 106
   Case 14 : Bas_ss = 105
   Case 15 : Bas_ss = 104
End Select
I2csend &H88 , Bas_ss
End Sub
'------------Tonesj--------------
Sub Tonesj:
Select Case H
Case 1 : Decr Tont
         If Tont < 1 Then Tont = 1
Case 0 : Incr Tont
         If Tont > 15 Then Tont = 15
End Select

Select Case Tont
   Case 1 : Tre_le = 112
   Case 2 : Tre_le = 113
   Case 3 : Tre_le = 114
   Case 4 : Tre_le = 115
   Case 5 : Tre_le = 116
   Case 6 : Tre_le = 117
   Case 7 : Tre_le = 118
   Case 8 : Tre_le = 119
   Case 9 : Tre_le = 126
   Case 10 : Tre_le = 125
   Case 11 : Tre_le = 124
   Case 12 : Tre_le = 123
   Case 13 : Tre_le = 122
   Case 14 : Tre_le = 121
   Case 15 : Tre_le = 120
End Select
I2csend &H88 , Tre_le
End Sub
'----------Inpt_gain-------------
Sub Inpt_gain:
Select Case H
Case 0 : Decr Gain
         If Gain < 1 Then Gain = 1
Case 1 : Incr Gain
         If Gain > 4 Then Gain = 4
End Select
Select Case Gain
   Case 1 : Gain_v = &B00011000
             Gain_d = 0
   Case 2 : Gain_v = &B00010000
            Gain_d = 6.25
   Case 3 : Gain_v = &B00001000
            Gain_d = 12.5
   Case 4 : Gain_v = &B00000000
            Gain_d = 18.75
End Select
Mask = Inp_ut And &B00000011
Select Case Mask
   Case 0 : Gain_d1 = Gain_d
   Case 1 : Gain_d2 = Gain_d
   Case 2 : Gain_d3 = Gain_d
   Case 3 : Gain_d4 = Gain_d
End Select
Temp = Inp_ut And &B11100111
Inp_ut = Temp Or Gain_v
I2csend &H88 , Inp_ut
W = 0
Timer1 = W
End Sub
'----------Inpt_chgn-------------
Sub Inpt_chgn:
Select Case H
Case 0 : Decr C
         If C < 1 Then C = 1
Case 1 : Incr C
         If C > 4 Then C = 4
End Select
Select Case C
   Case 1 : Mask = &B00000000
   Case 2 : Mask = &B00000001
   Case 3 : Mask = &B00000010
   Case 4 : Mask = &B00000011
End Select
Temp = Inp_ut And &B11111100
Inp_ut = Temp Or Mask
I2csend &H88 , Inp_ut
W = 0
Timer1 = W
End Sub
'----------Displ---------------
Sub Displ:
If A <> 1 Then
  If A <> 2 Then
   Locate 2 , 1                                             'set LCD first character position
   For Char_pos = 1 To Char_max                             'number of characters
    If Char_pos <= Bar_len Then                             'print one bar
      Lcd Chr(5)                                            'print special char                                         '
    Else
      Lcd Chr(32)                                           'print spaces to fill row
    End If
   Next
  End If
End If
W = 0
Timer1 = W
End Sub